package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.apiv2.Signer;
import io.accumulatenetwork.sdk.generated.errors.Error;
import io.accumulatenetwork.sdk.generated.errors.Status;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.TransactionResult;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("TransactionStatus")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class TransactionStatus implements Marshallable {
	private TxID txID;
	private Status code;
	private Error error;
	private TransactionResult result;
	private Url initiator;
	private Signer[] signers;

    //
	public TxID getTxID() {
	    return txID;
	}
	public void setTxID(final TxID value) {
	    this.txID = value;
	}

	public TransactionStatus txID(final TxID value) {
	    setTxID(value);
	    return this;
	}
	public Status getCode() {
	    return code;
	}
	public void setCode(final Status value) {
	    this.code = value;
	}

	public TransactionStatus code(final Status value) {
	    setCode(value);
	    return this;
	}
	public Error getError() {
	    return error;
	}
	public void setError(final Error value) {
	    this.error = value;
	}

	public TransactionStatus error(final Error value) {
	    setError(value);
	    return this;
	}
	public TransactionResult getResult() {
	    return result;
	}
	public void setResult(final TransactionResult value) {
	    this.result = value;
	}

	public TransactionStatus result(final TransactionResult value) {
	    setResult(value);
	    return this;
	}
	public Url getInitiator() {
	    return initiator;
	}
	public void setInitiator(final Url value) {
	    this.initiator = value;
	}

	public TransactionStatus initiator(final Url value) {
	    setInitiator(value);
	    return this;
	}
	public TransactionStatus initiator(final String value) {
	    setInitiator(Url.toAccURL(value));
	    return this;
	}
	public Signer[] getSigners() {
	    return signers;
	}
	public void setSigners(final Signer[] value) {
	    this.signers = value;
	}

	public TransactionStatus signers(final Signer[] value) {
	    setSigners(value);
	    return this;
	}

    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.txID == null)) {
            marshaller.writeTxid(1, this.txID);
        }
        if (!(this.code == null)) {
            marshaller.writeValue(2, code);
        }
        if (!(this.error == null)) {
            marshaller.writeValue(3, error);
        }
        if (!(this.result == null)) {
            marshaller.writeValue(4, result);
        }
        if (!(this.initiator == null)) {
            marshaller.writeUrl(5, this.initiator);
        }
        if (!(this.signers == null)) {
            marshaller.writeValue(6, signers);
        }
        return marshaller.array();
    }
}
